/**************************************************************************

	WWWC (upMail.dll)

	CreateBody.c

	(C) Copyright 1996-2000 By Tomoaki Nakashima. All right reserved.	
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE

#include "wwwcdll.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE			256			/* obt@TCY */
#define FMT_SIZE			32768		/* obt@TCY */


/**************************************************************************
	Global Variables
**************************************************************************/

extern char ListFormat[];
extern char Header[];
extern char Footer[];

extern int TargetFlag;
extern char TargetDir[100][BUF_SIZE];
extern int TargetDirCnt;


/******************************************************************************

	iStrCpy

	Rs[čŌ̃̕AhXԂ

******************************************************************************/

static char *iStrCpy(char *ret, char *buf)
{
	if(buf == NULL){
		return ret;
	}
	while(*buf != '\0'){
		*(ret++) = *(buf++);
	}
	*ret = '\0';
	return ret;
}


/******************************************************************************

	FmtToString

	̕ϊ

******************************************************************************/

void FmtToString(char *buf, char *ret)
{
	char *p, *r;

	for(p = buf, r = ret; *p != '\0'; p++){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			*(r++) = *(p++);
			*(r++) = *p;
			continue;
		}
		switch(*p)
		{
		case '\\':
			if(*(p + 1) == '\0') break;
			p++;
			switch(*p)
			{
			case 'r':
				*(r++) = '\r';
				break;

			case 'n':
				*(r++) = '\n';
				break;

			case 't':
				*(r++) = '\t';
				break;

			case '\\':
				*(r++) = '\\';
				break;
			}
			break;

		default:
			*(r++) = *p;
			break;
		}
	}
	*r = '\0';
}


/******************************************************************************

	FmtToParamString

	̕ϊ

******************************************************************************/

void FmtToParamString(char *buf, char *ret, int MaxLen)
{
	char datebuf[BUF_SIZE];
	char *p, *r;

	for(p = buf, r = ret; *p != '\0'; p++){
		if((r - ret) >= MaxLen) break;

		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			*(r++) = *(p++);
			*(r++) = *p;
			continue;
		}
		switch(*p)
		{
		case '%':
			if(*(p + 1) == '\0') break;
			p++;
			switch(*p)
			{
			case 'y':
				if(GetDateFormat(0, 0, NULL, "yyyy", datebuf, BUF_SIZE - 1) != 0){
					r = iStrCpy(r, datebuf);
				}
				break;

			case 'm':
				if(GetDateFormat(0, 0, NULL, "MM", datebuf, BUF_SIZE - 1) != 0){
					r = iStrCpy(r, datebuf);
				}
				break;

			case 'd':
				if(GetDateFormat(0, 0, NULL, "dd", datebuf, BUF_SIZE - 1) != 0){
					r = iStrCpy(r, datebuf);
				}
				break;

			case 'h':
				if(GetTimeFormat(0, 0, NULL, "HH", datebuf, BUF_SIZE - 1) != 0){
					r = iStrCpy(r, datebuf);
				}
				break;

			case 'n':
				if(GetTimeFormat(0, 0, NULL, "mm", datebuf, BUF_SIZE - 1) != 0){
					r = iStrCpy(r, datebuf);
				}
				break;

			case 's':
				if(GetTimeFormat(0, 0, NULL, "ss", datebuf, BUF_SIZE - 1) != 0){
					r = iStrCpy(r, datebuf);
				}
				break;

			case '%':
				*(r++) = '%';
				break;
			}
			break;

		default:
			*(r++) = *p;
			break;
		}
	}
	*r = '\0';
}


/******************************************************************************

	GetCharToInfo

	ɑΉ擾

******************************************************************************/

static char *GetCharToInfo(HWND hWnd, struct TPITEM *tpItemInfo, char c)
{
	static char path[BUF_SIZE];
	char *p = NULL;

	switch(c)
	{
	case 't':
		p = tpItemInfo->Title;
		break;

	case 'u':
		if(tpItemInfo->ViewURL != NULL && *tpItemInfo->ViewURL != '\0'){
			p = tpItemInfo->ViewURL;
		}else if(tpItemInfo->CheckURL != NULL){
			p = tpItemInfo->CheckURL;
		}
		break;

	case 'c':
		p = tpItemInfo->CheckURL;
		break;

	case 'v':
		p = tpItemInfo->ViewURL;
		break;

	case 's':
		p = tpItemInfo->Size;
		break;

	case 'd':
		p = tpItemInfo->Date;
		break;

	case 'C':
		p = tpItemInfo->CheckDate;
		break;

	case 'S':
		p = tpItemInfo->OldSize;
		break;

	case 'D':
		p = tpItemInfo->OldDate;
		break;

	case 'o':
		p = tpItemInfo->Option1;
		break;

	case 'O':
		p = tpItemInfo->Option2;
		break;

	case 'm':
		p = tpItemInfo->Comment;
		break;

	case 'e':
		p = tpItemInfo->ErrStatus;
		break;

	case 'l':
		p = tpItemInfo->DLLData1;
		break;

	case 'L':
		p = tpItemInfo->DLLData2;
		break;

	case 'p':
		SendMessage(hWnd, WM_FOLDER_GETWWWCPATH, tpItemInfo->hItem, (LPARAM)path);
		p = path;
		break;
	}
	return ((p != NULL) ? p : "");
}


/******************************************************************************

	GetBodySize

	{ɂTCY̎擾

******************************************************************************/

static int GetBodySize(HWND hWnd, struct TPITEM **ToolItemList, int ToolItemListCnt)
{
	char tmp[BUF_SIZE];
	char *p, *t;
	int len = 0;
	int i, j;

	for(i = 0; i < ToolItemListCnt; i++){
		if((*(ToolItemList + i)) == NULL){
			continue;
		}
		if(TargetFlag == 1){
			SendMessage(hWnd, WM_FOLDER_GETWWWCPATH, (*(ToolItemList + i))->hItem, (LPARAM)tmp);
			for(j = 0; j < TargetDirCnt; j++){
				if(lstrcmpi(tmp, TargetDir[j]) == 0){
					break;
				}
			}
			if(j >= TargetDirCnt){
				continue;
			}
		}

		for(p = ListFormat; *p != '\0'; p++){
			if(IsDBCSLeadByte((BYTE)*p) == TRUE){
				len += 2;
				p++;
				continue;
			}
			switch(*p)
			{
			case '\\':
				if(*(p + 1) == '\0'){
					break;
				}
				p++;
				switch(*p)
				{
				case 'r': case 'n':
				case 't': case '\\':
					len++;
					break;
				}
				break;

			case '%':
				if(*(p + 1) == '\0'){
					break;
				}
				p++;
				t = GetCharToInfo(hWnd, *(ToolItemList + i), *p);
				len += lstrlen(t);
				break;

			default:
				len++;
				break;
			}
		}
		len += 2;
	}
	return len;
}


/******************************************************************************

	CreateBody

	{̍쐬

******************************************************************************/

char *CreateBody(HWND hWnd,
				 struct TPITEM **ToolItemList, int ToolItemListCnt)
{
	char head[FMT_SIZE], foot[FMT_SIZE];
	char tmp[FMT_SIZE];
	char *buf;
	char *p, *r, *t;
	int len = 0;
	int i, j;

	len = GetBodySize(hWnd, ToolItemList, ToolItemListCnt);
	if(len <= 0){
		return NULL;
	}

	FmtToString(Header, tmp);
	FmtToParamString(tmp, head, FMT_SIZE - 10);

	FmtToString(Footer, tmp);
	FmtToParamString(tmp, foot, FMT_SIZE - 10);

	//TCY̌vZ
	len += lstrlen(head);
	len += lstrlen(foot);

	//[{̊m
	r = buf = LocalAlloc(LMEM_FIXED, len + 1);	
	if(buf == NULL){
		return NULL;
	}

	//wb_̐ݒ
	r = iStrCpy(r, head);

	//{̐ݒ
	for(i = 0; i < ToolItemListCnt; i++){
		if((*(ToolItemList + i)) == NULL){
			continue;
		}
		if(TargetFlag == 1){
			SendMessage(hWnd, WM_FOLDER_GETWWWCPATH, (*(ToolItemList + i))->hItem, (LPARAM)tmp);
			for(j = 0; j < TargetDirCnt; j++){
				if(lstrcmpi(tmp, TargetDir[j]) == 0){
					break;
				}
			}
			if(j >= TargetDirCnt){
				continue;
			}
		}

		for(p = ListFormat; *p != '\0'; p++){
			if(IsDBCSLeadByte((BYTE)*p) == TRUE){
				*(r++) = *(p++);
				*(r++) = *p;
				continue;
			}
			switch(*p)
			{
			case '\\':
				if(*(p + 1) == '\0'){
					break;
				}
				p++;
				switch(*p)
				{
				case 'r':
					*(r++) = '\r';
					break;

				case 'n':
					*(r++) = '\n';
					break;

				case 't':
					*(r++) = '\t';
					break;

				case '\\':
					*(r++) = '\\';
					break;
				}
				break;

			case '%':
				if(*(p + 1) == '\0'){
					break;
				}
				p++;
				t = GetCharToInfo(hWnd, *(ToolItemList + i), *p);
				r = iStrCpy(r, t);
				break;

			default:
				*(r++) = *p;
				break;
			}
		}
		r = iStrCpy(r, "\r\n");
	}
	
	//tb^̐ݒ
	r = iStrCpy(r, foot);
	*r = '\0';
	return buf;
}
/* End of source */
