/**************************************************************************

	WWWC (upMail.dll)

	smtp.c

	(C) Copyright 1996-2000 By Tomoaki Nakashima. All right reserved.	
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include <winsock.h>
#include "smtp.h"

/**************************************************************************
	Define
**************************************************************************/

#define X_Mailer			"upMail Ver 0.0.1"

#define BUF_SIZE			256		/* obt@TCY */
#define RECVSIZE			4096	/* Mobt@TCY */

#define SMTP_ERRORSTATUS	400

#define LINELEN				900
#define ENCODE_LINELEN		30


#define	IsKanji(i)			((i >= 0x81 && i <= 0x9F) || (i >= 0xE0 && i <= 0xFC))
#define	IsHankaku(i)		(i >= 0xa0 && i <= 0xdf)

#define SMTP_QUIT			-1
#define SMTP_HELO			0
#define SMTP_MAILFROM		1
#define SMTP_RCPTTO			2
#define SMTP_DATA			3
#define SMTP_BODY			4
#define SMTP_SENDBODY		5
#define SMTP_SENDEND		6


/**************************************************************************
	Global Variables
**************************************************************************/

static int MailFlag;

static char *body, *sbody, *SendPoint;
static int SendLen;

extern char Name[];				/* { */
extern char MailAddress[];		/* [AhX */
extern char ServerName[];		/* SMTPT[o */
extern char ServerPort[];		/* |[gԍ */

extern char SendSubject[];				/*  */
extern char ToAddress[100][BUF_SIZE];	/* M惁[AhX */
extern int ToAddressCnt;



/******************************************************************************

	iStrCpy

	Rs[čŌ̃̕AhXԂ

******************************************************************************/

static char *iStrCpy(char *ret, char *buf)
{
	if(buf == NULL){
		return ret;
	}
	while(*buf != '\0'){
		*(ret++) = *(buf++);
	}
	*ret = '\0';
	return ret;
}


/******************************************************************************

	GetNextQuote

	̎̋؂ʒu܂Ń|C^ړ

******************************************************************************/

static char *GetNextQuote(char *buf, char qStr)
{
	char *p;

	for(p = buf; *p != '\0'; p++){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE || *p == '\\'){
			p++;
			continue;
		}
		if(*p == qStr){
			break;
		}
	}
	return p;
}


/******************************************************************************

	GetMailAddress

	񂩂烁[AhX̒o
		MailAddress
		Comment <MailAddress>
		MailAddress (Comment)

******************************************************************************/

static char *GetMailAddress(char *buf, char *ret)
{
	BOOL kFlag = FALSE;
	char *p, *r;

	for(p = buf, r = ret; *p != '\0'; p++){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			*(r++) = *(p++);
			*(r++) = *p;
			continue;
		}
		switch(*p)
		{
		case ' ':
		case '\t':
		case '\r':
		case '\n':
			break;

		case '\"':
			p = GetNextQuote(p + 1, '\"');
			break;

		case '(':
			p = GetNextQuote(p + 1, ')');
			break;

		case '<':
			r = ret;
			kFlag = TRUE;
			break;

		case '>':
			if(kFlag == FALSE){
				*(r++) = *p;
				break;
			}
			*r = '\0';
			return GetNextQuote(p + 1, ',');

		case ',':
			*r = '\0';
			return p;

		default:
			*(r++) = *p;
			break;
		}
	}
	*r = '\0';
	return p;
}


/******************************************************************************

	GetTimeString

	ԕ̎擾

******************************************************************************/

static void GetTimeString(char *buf)
{
	TIME_ZONE_INFORMATION tmzi;
	SYSTEMTIME st;
	DWORD ret;
	TCHAR c;
	int tmz;
	const char *Week[] = {
		"Sun", "Mon", "Tue", "Wed",
		"Thu", "Fri", "Sat",
	};
	const char *Month[] = {
		"Jan", "Feb", "Mar", "Apr",
		"May", "Jun", "Jul", "Aug",
		"Sep", "Oct", "Nov", "Dec",
	};

	GetLocalTime(&st);

	tmz = 900;	//ftHg͓{ɂ
	c = '+';
	ret = GetTimeZoneInformation(&tmzi);
	if(ret != TIME_ZONE_ID_UNKNOWN && ret != 0xFFFFFFFF){
		if(tmzi.Bias < 0){
			tmzi.Bias *= -1;
		}else{
			c = '-';
		}
		tmz = (tmzi.Bias / 60) * 100 + tmzi.Bias % 60;
	}

	wsprintf(buf, "%s, %d %s %d %02d:%02d:%02d %c%04d", Week[st.wDayOfWeek],
		st.wDay, Month[st.wMonth - 1], st.wYear, st.wHour, st.wMinute, st.wSecond, c, tmz);
}


/******************************************************************************

	HanToZen

	pJiSpJiɕϊ

******************************************************************************/

static int HanToZen(unsigned int *zenkaku, unsigned char *str)
{
	const unsigned int z[64] = {
		0x2121,0x2123,0x2156,0x2157,0x2122,0x2126,0x2572,0x2521,
		0x2523,0x2525,0x2527,0x2529,0x2563,0x2565,0x2567,0x2543,
		0x213c,0x2522,0x2524,0x2526,0x2528,0x252a,0x252b,0x252d,
		0x252f,0x2531,0x2533,0x2535,0x2537,0x2539,0x253b,0x253d,
		0x253f,0x2541,0x2544,0x2546,0x2548,0x254a,0x254b,0x254c,
		0x254d,0x254e,0x254f,0x2552,0x2555,0x2558,0x255b,0x255e,
		0x255f,0x2560,0x2561,0x2562,0x2564,0x2566,0x2568,0x2569,
		0x256a,0x256b,0x256c,0x256d,0x256f,0x2573,0x212b,0x212c};
	typedef struct {
		unsigned char han;
		unsigned int zen;
	} TBL;
	const TBL daku[] = {
		{0xb3,0x2574},{0xb6,0x252c},{0xb7,0x252e},{0xb8,0x2530},
		{0xb9,0x2532},{0xba,0x2534},{0xbb,0x2536},{0xbc,0x2538},
		{0xbd,0x253a},{0xbe,0x253c},{0xbf,0x253e},{0xc0,0x2540},
		{0xc1,0x2542},{0xc2,0x2545},{0xc3,0x2547},{0xc4,0x2549},
		{0xca,0x2550},{0xcb,0x2553},{0xcc,0x2556},{0xcd,0x2559},
		{0xce,0x255c},{0,0}};
	const TBL handaku[] = {
		{0xca,0x2551},{0xcb,0x2554},{0xcc,0x2557},{0xcd,0x255a},
		{0xce,0x255d},{0,0}};
	int i;

	if(*(str+1) == 0xde){           /*  */
		for(i = 0;(daku + i)->zen != 0;i++)
			if(*str == (daku + i)->han){
			*zenkaku = (daku + i)->zen;
			return 2;
		}
	}else if(*(str+1) == 0xdf){    /*  */
	for(i = 0;(handaku + i)->zen != 0;i++)
		if(*str == (handaku + i)->han){
			*zenkaku = (handaku + i)->zen;
			return 2;
		}
	}
	*zenkaku = z[*str - 0xa0];
	return 1;
}


/******************************************************************************

	JisShift

	SJIS2oCgJISɕϊ

******************************************************************************/

static void JisShift(int *ph,int *pl)
{
	*ph = *ph & 0xff;
	*pl = *pl & 0xff;

	if(*ph <= 0x9F){
		if(*pl < 0x9F){
			*ph = (*ph << 1) - 0xE1;
		}else{
			*ph = (*ph << 1) - 0xE0;
		}
	}else{
		if(*pl < 0x9F){
			*ph = (*ph << 1) - 0x161;
		}else{
			*ph = (*ph << 1) - 0x160;
		}
	}

	if(*pl < 0x7F){
		*pl -= 0x1F;
	}else if(*pl < 0x9F){
		*pl -= 0x20;
	}else{
		*pl -= 0x7E;
	}
}


/******************************************************************************

	SjisToJis

	SJISJISɕϊ

******************************************************************************/

static void SjisToJis(unsigned char *buf,unsigned char *ret)
{
#define ESC					0x1B
	unsigned char *p,*r;
	int knaji;
	int c,d;
	int rc;
	unsigned int e;
	unsigned int hib, lob;

	p = buf;
	r = ret;
	knaji = 0;

	while((c = *(p++)) != '\0'){
		switch(knaji)
		{
		case 0:
			if(IsKanji((unsigned char)c) == TRUE || IsHankaku((unsigned char)c) == TRUE){
				*(r++) = ESC;
				*(r++) = '$';
				*(r++) = 'B';

				if(IsKanji((unsigned char)c) == TRUE){
					d = *(p++);
					JisShift(&c,&d);
					*(r++) = c;
					*(r++) = d;
				}else{
					rc = HanToZen(&e,p - 1);
					if(rc != 1){
						p++;
					}
					hib = (e >> 8) & 0xff;
					lob = e & 0xff;
					*(r++) = hib;
					*(r++) = lob;
				}
				knaji = 1;
			}else{
				*(r++) = c;
			}
			break;
		case 1:
			if(IsKanji((unsigned char)c) == FALSE && IsHankaku((unsigned char)c) == FALSE){
				*(r++) = ESC;
				*(r++) = '(';
				*(r++) = 'B';
				*(r++) = c;
				knaji = 0;
			}else{
				if(IsKanji((unsigned char)c) == TRUE){
					d = *(p++);
					JisShift(&c,&d);
					*(r++) = c;
					*(r++) = d;
				}else{
					rc = HanToZen(&e,p - 1);
					if(rc != 1){
						p++;
					}
					hib = (e >> 8) & 0xff;
					lob = e & 0xff;
					*(r++) = hib;
					*(r++) = lob;
				}
			}
			break;
		}
	}
	if(knaji == 1){
		*(r++) = ESC;
		*(r++) = '(';
		*(r++) = 'B';
	}
	*r = '\0';
}


/******************************************************************************

	eBase

	BASE64̃GR[hs

******************************************************************************/

static void eBase(char *buf, char *ret, int size)
{
	char tmp, tmp2;
	char *r;
	int c, i;
	const char Base[] =
		"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
		"abcdefghijklmnopqrstuvwxyz"
		"0123456789+/";

	i = 0;
	r = ret;
	while(1){
		if((size == 0 && *(buf + i) == '\0') || (size > 0 && size <= i)){
			break;
		}
		c = (*(buf + i) & 0xFC) >> 2;
		*(r++) = *(Base + c);
		i++;

		if((size == 0 && *(buf + i) == '\0') || (size > 0 && size <= i)){
			*(buf + i) = 0;
			tmp2 = (char)(*(buf + i - 1) << 4) & 0x30;
			tmp = (char)(*(buf + i) >> 4) & 0xF;
			c = tmp2 | tmp;
			*(r++) = *(Base + c);
			*(r++) = '=';
			*(r++) = '=';
			break;
		}
		tmp2 = (char)(*(buf + i - 1) << 4) & 0x30;
		tmp = (char)(*(buf + i) >> 4) & 0xF;
		c = tmp2 | tmp;
		*(r++) = *(Base + c);

		if((size == 0 && *(buf + i + 1) == '\0') || (size > 0 && size <= (i + 1))){
			*(buf + i + 1) = 0;
			tmp2 = (char)(*(buf + i) << 2) & 0x3C;
			tmp = (char)(*(buf + i + 1) >> 6) & 0x3;
			c = tmp2 | tmp;
			*(r++) = *(Base + c);
			*(r++) = '=';
			break;
		}

		tmp2 = (char)(*(buf + i) << 2) & 0x3C;
		tmp = (char)(*(buf + i + 1) >> 6) & 0x3;
		c = tmp2 | tmp;
		*(r++) = *(Base + c);
		i++;

		c = *(buf + i) & 0x3F;
		*(r++) = *(Base + c);
		i++;
	}
	*r = '\0';
}


/******************************************************************************

	GetLeadLen

	MIMEGR[h̃TCY̎擾

******************************************************************************/

static char *GetLeadLen(char *p, int *len, int *SpCnt)
{
	char *t, *sp;
	BOOL eFlag;

	//SpGR[h
	*len = 0;
	*SpCnt = 0;
	t = p;
	eFlag = FALSE;
	while(*t != '\0'){
		if(IsKanji((unsigned char)*t) == TRUE){
			//Sp
			if((*len + *SpCnt + 3) >= ENCODE_LINELEN){
				break;
			}
			if(eFlag == FALSE){
				eFlag = TRUE;
				*SpCnt += 3;	//JIS̎n[GXP[v
			}
			t += 2;
			*len += 2;

		}else if(IsHankaku((unsigned char)*t) == TRUE){
			//pJi
			if((*len + *SpCnt + 3) >= ENCODE_LINELEN){
				break;
			}
			if(eFlag == FALSE){
				eFlag = TRUE;
				*SpCnt += 3;	//JIS̎n[GXP[v
			}
			t++;
			(*len)++;
			(*SpCnt)++;			//Spɕϊ镪̃TCY

		}else if(*t == ' '){
			//
			for(sp = t; *sp == ' '; sp++);
			if(IsKanji((unsigned char)*sp) == FALSE && IsHankaku((unsigned char)*sp) == FALSE){
				break;
			}
			if(eFlag == TRUE){
				eFlag = FALSE;
				*SpCnt += 3;	//JIS̏I[GXP[v
			}
			t++;
			(*len)++;

		}else{
			break;
		}
	}
	(*len)++;
	*SpCnt += 3;	//JIS̏I[GXP[v
	return t;
}


/******************************************************************************

	GetMIMEencodeSize

	MIMEGR[hŝɕKvȃTCY̎擾

******************************************************************************/

static int GetMIMEencodeSize(char *wbuf)
{
	char *p;
	int Len;
	int i = 0;
	int ret = 0;
	int SpCnt;

	p = wbuf;
	while(*p != '\0'){
		if(i >= LINELEN || (i > 0 && (IsKanji((unsigned char)*p) == TRUE || IsHankaku((unsigned char)*p) == TRUE))){
			ret += 3;
			i = 0;
		}
		if(IsKanji((unsigned char)*p) == TRUE || IsHankaku((unsigned char)*p) == TRUE){
			p = GetLeadLen(p, &Len, &SpCnt);
			Len += SpCnt;			//JIS
			Len = Len * 2 + 4;		//Base64

			Len += lstrlen("=?ISO-2022-JP?B??=");

			ret += Len;
			if(*p == ' '){
				i += Len;
			}else{
				i = LINELEN;
			}

		}else{
			ret++;
			p++;
			if(*p == '\r'){
				i = 0;
			}else{
				i++;
			}
		}
	}
	return ret;
}


/******************************************************************************

	MIMEencode

	MIMẼGR[hs

******************************************************************************/

static BOOL MIMEencode(char *wbuf, char *ret)
{
	char *buf;
	char *jbuf;
	char *p, *r, *t;
	int Len;
	int i = 0;
	int SpCnt;

	p = wbuf;
	r = ret;
	while(*p != '\0'){
		if(i >= LINELEN || (i > 0 && (IsKanji((unsigned char)*p) == TRUE || IsHankaku((unsigned char)*p) == TRUE))){
			*(r++) = '\r';
			*(r++) = '\n';
			*(r++) = ' ';
			i = 0;
		}
		if(IsKanji((unsigned char)*p) == TRUE || IsHankaku((unsigned char)*p) == TRUE){
			t = GetLeadLen(p, &Len, &SpCnt);

			buf = (char *)LocalAlloc(LMEM_FIXED, Len + 1);
			if(buf == NULL){
				return FALSE;
			}
			lstrcpyn(buf, p, Len);
			*(buf + Len) = '\0';
			p = t;

			//JISɕϊ
			jbuf = (char *)LocalAlloc(LMEM_FIXED, Len + SpCnt + 1);
			if(jbuf == NULL){
				LocalFree(buf);
				return FALSE;
			}
			SjisToJis((unsigned char *)buf, (unsigned char *)jbuf);
			LocalFree(buf);

			//Base64ŃGR[h
			buf = (char *)LocalAlloc(LMEM_FIXED, lstrlen(jbuf) * 2 + 4);
			if(buf == NULL){
				LocalFree(jbuf);
				return FALSE;
			}
			eBase(jbuf, buf, 0);
			LocalFree(jbuf);

			Len = wsprintf(r, "=?ISO-2022-JP?B?%s?=", buf);
			LocalFree(buf);
			r += Len;

			if(*p == ' '){
				i += Len;
			}else{
				i = LINELEN;
			}
		}else{
			*(r++) = *(p++);
			if(*p == '\r'){
				i = 0;
			}else{
				i++;
			}
		}
	}
	*r = '\0';
	return TRUE;
}


/******************************************************************************

	CreateMessageId

	Message-Id 𐶐

******************************************************************************/

void CreateMessageId(char *MailAddress, char *ret)
{
	SYSTEMTIME st;
	int i;

	GetLocalTime(&st);

	i = st.wYear + st.wMonth + st.wDay + st.wHour + st.wMinute + st.wSecond;
	srand((unsigned)i);

	wsprintf(ret, "<%04d%02d%02d%02d%02d%02d.%4X%4X.%s>",
		st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, 
		rand(), rand(), MailAddress);
}


/******************************************************************************

	SendBody

	wb_MƑM{̍쐬

******************************************************************************/

static BOOL SendBody(HWND hWnd, SOCKET soc, char *ErrStr)
{
	char sendbuf[BUF_SIZE * 2];						/* Mobt@ */
	char *p, *r, *t;
	int len, i;

	/* wb_̑M */
	wsprintf(sendbuf, "From: %s <%s>\r\n", Name, MailAddress);
	if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
		wsprintf(ErrStr, "T[oւ̑Ms");
		return FALSE;
	}

	r = (char *)LocalAlloc(LMEM_FIXED, (ToAddressCnt * (BUF_SIZE + 2)) + 7);
	if(r != NULL){
		p = r;
		for(i = 0; i < ToAddressCnt; i++){
			if(i != 0){
				p = iStrCpy(p, ", ");
			}
			p = iStrCpy(p, ToAddress[i]);
		}

		len = GetMIMEencodeSize(r);
		p = (char *)LocalAlloc(LMEM_FIXED, len + lstrlen("To: \r\n") + 1);
		if(p != NULL){
			t = iStrCpy(p, "To: ");
			MIMEencode(r, t);
			lstrcat(p, "\r\n");
			if(send(soc, p, lstrlen(p), 0) == SOCKET_ERROR){
				LocalFree(r);
				LocalFree(p);
				wsprintf(ErrStr, "T[oւ̑Ms");
				return FALSE;
			}
			LocalFree(p);
		}
		LocalFree(r);
	}

	p = iStrCpy(sendbuf, "Date: ");
	GetTimeString(p);
	lstrcat(sendbuf, "\r\n");
	if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
		wsprintf(ErrStr, "T[oւ̑Ms");
		return FALSE;
	}

	/* Subject ̑M */
	len = GetMIMEencodeSize(SendSubject);
	p = (char *)LocalAlloc(LMEM_FIXED, len + lstrlen("Subject: \r\n") + 1);
	if(p != NULL){
		r = iStrCpy(p, "Subject: ");
		MIMEencode(SendSubject, r);
		lstrcat(p, "\r\n");
		if(send(soc, p, lstrlen(p), 0) == SOCKET_ERROR){
			LocalFree(p);
			wsprintf(ErrStr, "T[oւ̑Ms");
			return FALSE;
		}
		LocalFree(p);
	}

	p = iStrCpy(sendbuf, "Message-Id: ");
	CreateMessageId(MailAddress, p);
	lstrcat(sendbuf, "\r\n");
	if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
		wsprintf(ErrStr, "T[oւ̑Ms");
		return FALSE;
	}

	wsprintf(sendbuf, "MIME-Version: 1.0\r\n");
	if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
		wsprintf(ErrStr, "T[oւ̑Ms");
		return FALSE;
	}
	wsprintf(sendbuf, "Content-Type: text/plain; charset=ISO-2022-JP\r\n");
	if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
		wsprintf(ErrStr, "T[oւ̑Ms");
		return FALSE;
	}
	wsprintf(sendbuf, "Content-Transfer-Encoding: 7bit\r\n");
	if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
		wsprintf(ErrStr, "T[oւ̑Ms");
		return FALSE;
	}

	wsprintf(sendbuf, "X-Mailer: %s\r\n\r\n", X_Mailer);
	if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
		wsprintf(ErrStr, "T[oւ̑Ms");
		return FALSE;
	}

	/* JISɕϊ */
	body = (char *)LocalAlloc(LMEM_FIXED, (lstrlen(sbody) + 1) * 4);
	if(body == NULL){
		wsprintf(ErrStr, "̊mۂɎs");
		return -1;
	}
	SjisToJis((unsigned char *)sbody, (unsigned char *)body);
	if(body == NULL){
		wsprintf(ErrStr, "{擾Ɏs");
		return FALSE;
	}

	SendPoint = body;
	SendLen = 0;

	/* M̃Cxg쐬 */
	if(WSAAsyncSelect(soc, hWnd, WSOCK_SELECT, FD_CONNECT | FD_READ | FD_WRITE | FD_CLOSE) == SOCKET_ERROR){
		LocalFree(body);
		body = NULL;
		lstrcpy(ErrStr, "CxgĐݒɎs܂");
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	SMTPRecv

	M

******************************************************************************/

static BOOL SMTPRecv(int soc, char *buf, int len)
{
    int recvlen = 0;
    char *p;

    memset(buf, '\0', len);

	p = buf;
    while(strstr(buf, "\r\n") == NULL){
		recvlen = recv(soc, p, len - 1, 0);
		p += recvlen;
		len -= recvlen;
		if(len <= 1) return FALSE;
    }
    return TRUE;
}


/******************************************************************************

	GetResponseStat

	X|X̉

******************************************************************************/

static int GetResponseStat(char *buf)
{
	char stat[5];
	int ret;

	/* Xe[^XR[h擾 */
	strncpy(stat, buf, 4);
	ret = atoi(stat);
	if(ret <= 0){
		ret = SMTP_ERRORSTATUS;
	}
	return ret;
}


/******************************************************************************

	SMTPRes

	X|X̎擾

******************************************************************************/

static BOOL SMTPRes(HWND hWnd, SOCKET soc, char *ErrStr)
{
	char recvbuf[RECVSIZE];						/* Mobt@ */

	if(SMTPRecv(soc, recvbuf, RECVSIZE) == FALSE){
		wsprintf(ErrStr, "T[o̎Ms");
		return FALSE;
	}

	/* MbZ[W\ */
	SendMessage(hWnd, WSOCK_MESSAGE, 0, (LPARAM)recvbuf);

	if(GetResponseStat(recvbuf) >= SMTP_ERRORSTATUS){
		wsprintf(ErrStr, "%s\n", recvbuf);
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	WSock_Init

	WinSock̏s

******************************************************************************/

BOOL WSock_Init(char *ErrStr)
{
	WSADATA wsaData;
	WORD wVersionRequested;
	int  nErrorStatus;

	/* WinSock̏s */
	wVersionRequested = MAKEWORD(1,1);						/* o[W 1.1 v */
	nErrorStatus = WSAStartup(wVersionRequested, &wsaData);
	if(atexit((void (*)(void))(WSACleanup))){				/* IWinSock̃\[X悤ɂĂ */
		wsprintf(ErrStr, "atexit(WSACleanup)s");
		return FALSE;
	}
	if(nErrorStatus != 0){
		wsprintf(ErrStr, "WinSock̏s");
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	ConnectServer

	T[oɐڑ

******************************************************************************/

SOCKET ConnectServer(HWND hWnd, char *snedbody, char *ErrStr)
{
	SOCKET Soc;
	struct  sockaddr_in serversockaddr;
	struct hostent *serverhostent;				/* T[ȍw|C^ */
	unsigned long serveraddr;					/* T[oIPAhX */
	unsigned short port = 25;					/* |[gԍ */

	if(ToAddressCnt == 0){
		lstrcpy(ErrStr, "悪ݒ肳Ă܂");
		return -1;
	}

	if(snedbody == NULL || *snedbody == '\0'){
		lstrcpy(ErrStr, "{ݒ肳Ă܂");
		return -1;
	}
	sbody = snedbody;

	if(ServerName == NULL || *ServerName == '\0'){
		lstrcpy(ErrStr, "T[oݒ肳Ă܂");
		return -1;
	}

	/* IPAhX̎擾 */
	SendMessage(hWnd, WSOCK_MESSAGE, 0, (LPARAM)"IPAhX擾...");
	serveraddr = inet_addr(ServerName);
	if(serveraddr == -1){
		serverhostent = gethostbyname(ServerName);
		if(serverhostent != NULL){
			serveraddr = ((struct in_addr *)serverhostent->h_addr_list[0])->s_addr;
		}else{
			lstrcpy(ErrStr, "IPAhX擾Ɏs܂");
			return -1;
		}
	}
	if(*ServerPort != '\0'){
		port = (unsigned short)atoi(ServerPort);
	}

	Soc = socket(PF_INET, SOCK_STREAM, 0);
	if(Soc == INVALID_SOCKET){
		lstrcpy(ErrStr, "\Pbg쐬Ɏs܂");
		return -1;
	}

	serversockaddr.sin_family		= AF_INET;							/* C^[lbg̏ꍇ */
	serversockaddr.sin_addr.s_addr	= serveraddr;						/* T[oIPAhX */
	serversockaddr.sin_port			= htons((unsigned short)port);		/* |[gԍ */
	memset(serversockaddr.sin_zero, 0, sizeof(serversockaddr.sin_zero));

	/* \Pbg̃Cxg̐ݒ */
	if(WSAAsyncSelect(Soc, hWnd, WSOCK_SELECT, FD_CONNECT | FD_READ | FD_CLOSE) == SOCKET_ERROR){
		lstrcpy(ErrStr, "CxgݒɎs܂");
		return -1;
	}

	/* ڑJn */
	SendMessage(hWnd, WSOCK_MESSAGE, 0, (LPARAM)"T[oɐڑ...");
	MailFlag = SMTP_HELO;
	if(connect(Soc, (struct sockaddr *)&serversockaddr, sizeof(serversockaddr)) == SOCKET_ERROR){
		if(WSAGetLastError() == WSAEWOULDBLOCK){
			return Soc;
		}
		lstrcpy(ErrStr, "T[oڑɎs܂");
		return -1;
	}
	return Soc;
}


/******************************************************************************

	SendProc

	{MvV[W

******************************************************************************/

BOOL SendProc(HWND hWnd, SOCKET soc, char *ErrStr)
{
	char sendbuf[BUF_SIZE];
	int len;

	if(body == NULL){
		lstrcpy(ErrStr, "MɎs܂");
		return FALSE;
	}

	/* MI */
	if(*SendPoint == '\0'){
		LocalFree(body);
		body = NULL;
		if(send(soc, "\r\n.\r\n", lstrlen("\r\n.\r\n"), 0) == SOCKET_ERROR){
			if(WSAGetLastError() == WSAEWOULDBLOCK){
				return TRUE;
			}
			lstrcpy(ErrStr, "MɎs܂");
			return FALSE;
		}
		MailFlag = SMTP_SENDEND;
		if(WSAAsyncSelect(soc, hWnd, WSOCK_SELECT, FD_CONNECT | FD_READ | FD_CLOSE) == SOCKET_ERROR){
			LocalFree(body);
			body = NULL;
			lstrcpy(ErrStr, "CxgݒɎs܂");
			return FALSE;
		}
		return TRUE;
	}

	/* đM */
	lstrcpyn(sendbuf, SendPoint, BUF_SIZE - 1);
	if((len = send(soc, sendbuf, lstrlen(sendbuf), 0)) == SOCKET_ERROR){
		if(WSAGetLastError() == WSAEWOULDBLOCK){
			return TRUE;
		}
		LocalFree(body);
		body = NULL;
		lstrcpy(ErrStr, "MɎs܂");
		return FALSE;
	}

	SendPoint += len;
	SendLen += len;
	/* Cxgݒ肵Ȃ */
	if(WSAAsyncSelect(soc, hWnd, WSOCK_SELECT, FD_CONNECT | FD_READ | FD_WRITE | FD_CLOSE) == SOCKET_ERROR){
		LocalFree(body);
		body = NULL;
		lstrcpy(ErrStr, "CxgݒɎs܂");
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	SendMailProc

	SMTP̉vV[W

******************************************************************************/

BOOL SendMailProc(HWND hWnd, SOCKET soc, char *ErrStr)
{
	char sendbuf[BUF_SIZE];						/* Mobt@ */
	char buf[BUF_SIZE];
	static int ToIndex;

	if(SMTPRes(hWnd, soc, ErrStr) == FALSE){
		return FALSE;
	}
	switch(MailFlag){
	/* HELO ̑M */
	case SMTP_HELO:
		wsprintf(sendbuf, "HELO %s\r\n", ServerName);
		if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
			lstrcpy(ErrStr, "MɎs܂");
			return FALSE;
		}
		MailFlag = SMTP_MAILFROM;
		break;

	/* MAIL FROM ̑M */
	case SMTP_MAILFROM:
		wsprintf(sendbuf, "MAIL FROM:<%s>\r\n", MailAddress);
		if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
			lstrcpy(ErrStr, "MɎs܂");
			return FALSE;
		}
		MailFlag = SMTP_RCPTTO;
		ToIndex = 0;
		break;

	/* RCPT TO ̑M */
	case SMTP_RCPTTO:
		GetMailAddress(ToAddress[ToIndex], buf);
		wsprintf(sendbuf, "RCPT TO:<%s>\r\n", buf);
		if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
			lstrcpy(ErrStr, "MɎs܂");
			return FALSE;
		}
		ToIndex++;
		if(ToIndex >= ToAddressCnt){
			MailFlag = SMTP_DATA;
		}else{
			MailFlag = SMTP_RCPTTO;
		}
		break;

	/* DATA ̑M */
	case SMTP_DATA:
		lstrcpy(sendbuf, "DATA\r\n");
		if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
			lstrcpy(ErrStr, "MɎs܂");
			return FALSE;
		}
		MailFlag = SMTP_BODY;
		break;

	/* wb_Ɩ{̑M */
	case SMTP_BODY:
		if(SendBody(hWnd, soc, ErrStr) == FALSE){
			return FALSE;
		}
		MailFlag = SMTP_SENDBODY;
		lstrcpy(sendbuf, "wb_M...");
		break;

	/* {̑M */
	case SMTP_SENDBODY:
		lstrcpy(sendbuf, "{M...");
		break;

	/* QUIT ̑M */
	case SMTP_SENDEND:
		lstrcpy(sendbuf, "QUIT\r\n");
		if(send(soc, sendbuf, lstrlen(sendbuf), 0) == SOCKET_ERROR){
			lstrcpy(ErrStr, "MɎs܂");
			return FALSE;
		}
		MailFlag = SMTP_QUIT;
		break;

	case SMTP_QUIT:
		lstrcpy(sendbuf, "ؒfҋ@...");
		break;
	}
	/* Ԃ\ */
	SendMessage(hWnd, WSOCK_MESSAGE, 0, (LPARAM)sendbuf);
	return TRUE;
}


/******************************************************************************

	SockeClose

	\Pbg̔j

******************************************************************************/

void SockeClose(HWND hWnd, SOCKET soc)
{
	/* Cxgj */
	WSAAsyncSelect(soc, hWnd, 0, 0);

	/* M𖳌ɂ */
	shutdown(soc,2);
	/* \Pbgj */
	closesocket(soc);

	if(body != NULL){
		LocalFree(body);
		body = NULL;
	}
}
/* End of source */
